unit TeeChartLicense;

interface

uses
  SysUtils, Registry, Windows, StrUtils, DateUtils;

function GenerateLicenseNumber(AFrom, ATo: Cardinal): string;
function CalcPassword(LicenseNumber: string): string;

implementation

procedure StoreRandom(Temp: string);
const
  SUB_KEY = '{6B470466-CA2E-46F1-B640-39510F3050CA}';
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    if Length(Temp) < 8 then
      Temp := StringOfChar('0', 8 - Length(Temp)) + Temp;
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('System\' + SUB_KEY, True) then
    begin
      Reg.WriteString('', MidStr(Temp, 5, 4) + Format('%.f', [IncYear(Today, 100)]) + LeftStr(Temp, 4));
    end;
    Reg.CloseKey;
  finally
    FreeAndNil(Reg);
  end;
end;

function GenerateLicenseNumber(AFrom, ATo: Cardinal): string;
begin
  Randomize;
  Result := IntToStr(Cardinal(Random(ATo - AFrom)) + AFrom);
  StoreRandom(Result);
end;

function CalcPassword(LicenseNumber: string): string;
var
  i: Integer;
  Temp: Integer;
  Ch: Char;
begin
  Result := '';
  for i := 0 to Length(LicenseNumber) - 1 do
  begin
    Temp := StrToInt(LicenseNumber[i + 1]);
    Temp := Temp + i + 2;
    if Temp > 9 then
      Temp := Temp - 10;
    Result := Result + IntToStr(Temp);
    Temp := StrToInt(LicenseNumber[i + 1]);
    Temp := Temp + (i + 1) - 2;
    if Temp > 9 then
      Temp := Temp - 10;
    Result := Result + IntToStr(Temp);
  end;
  Result := Result + IntToStr(Length(LicenseNumber) + 1);
  for i := 1 to (Length(Result) div 2) do
  begin
    Ch := Result[i];
    Result[i] := Result[Length(Result) - (i - 1)];
    Result[Length(Result) - (i - 1)] := Ch;
  end;
end;

end.
