unit TeeChartProduct;

interface

uses
  Classes, SysUtils, Windows, Dialogs;

type
  TChartProduct = record
    Name: string;
    Description: string;
    LicNumStart: Cardinal;
    LicNumEnd: Cardinal;
  end;

  PTChartProduct = ^TChartProduct;

var
  TChartProductList: TStringList;

implementation

uses
  DES;

function DecryptLicNumRange(): string;
var
  Stream: TResourceStream;
  Src, Key, IV: TBytes;
  AResult: AnsiString;
const
  DES_KEY: AnsiString = '?ZF=? ,m';
begin
  Result := '';
  Stream := TResourceStream.Create(hInstance, 'LicNumRange', RT_RCDATA);
  try
    if Stream.Size = 0 then
      Exit;
    SetLength(Src, Stream.Size);
    Stream.Position := 0;
    Stream.Read(Src[0], Length(Src));
  finally
    Stream.Free;
  end;
  SetLength(Key, Length(DES_KEY));
  SetLength(IV, Length(DES_KEY));
  Move(DES_KEY[1], Key[0], Length(DES_KEY));
  Move(DES_KEY[1], IV[0], Length(DES_KEY));
  Src := DESDecrypt(Src, Key, IV);
  if Length(Src) = 0 then
    Exit;
  SetLength(AResult, Length(Src));
  Move(Src[0], Pointer(AResult)^, Length(Src));
  Result := string(AResult);
end;

procedure InitTChartProducts(ProductList: TStringList);
var
  Product: PTChartProduct;
  StringList, ValueList: TStringList;
  i: Integer;
begin
  StringList := TStringList.Create;
  ValueList := TStringList.Create;
  try
    StringList.Text := DecryptLicNumRange;
    ValueList.Delimiter := #9;
    ValueList.StrictDelimiter := True;
    for i := 1 to StringList.Count - 1 do
    begin
      if (Pos('distribuidos', StringList.Strings[i]) > 0) or (Pos('Admin', StringList.Strings[i]) > 0) or
        (Pos('Evaluation', StringList.Strings[i]) > 0) then
        Continue;

      ValueList.DelimitedText := StringList.Strings[i];
      if ValueList.Count < 5 then
        Continue;
      New(Product);
      Product^.Name := ValueList.Strings[1];
      Product^.Description := ValueList.Strings[2];
      Product^.LicNumStart := StrToInt(ValueList.Strings[4]);
      if ValueList.Count > 5 then
        Product^.LicNumEnd := StrToIntDef(ValueList.Strings[5], MaxInt)
      else
        Product^.LicNumEnd := MaxInt;
      ProductList.AddObject(Product^.Name, TObject(Product));
    end;
  finally
    FreeAndNil(ValueList);
    FreeAndNil(StringList);
  end;
end;

procedure FinallyTChartProducts(ProductList: TStringList);
var
  Product: PTChartProduct;
begin
  while ProductList.Count > 0 do
  begin
    Product := PTChartProduct(ProductList.Objects[0]);
    if Product <> nil then
      Dispose(Product);
    ProductList.Delete(0);
  end;
end;

initialization

TChartProductList := TStringList.Create;
InitTChartProducts(TChartProductList);

finalization

FinallyTChartProducts(TChartProductList);
FreeAndNil(TChartProductList);

end.
